package com.objis.demohibernate.servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Controleur extends HttpServlet {

	private static final long serialVersionUID = 1L;

	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		// plus besoin d'ouvrir et de fermer la session, le filtre s'en charge
			// Session session = getSession();
			// closeSession(session);
		
		resp.setContentType("text/html");
		PrintWriter out = resp.getWriter();
		out.println("<HTML>");
		out.println("<HEADER><TITLE>Ouverture / Fermeture de la Session Hibernate dans le controleur</TITLE></HEADER>");
		out.println("<BODY>");
		out.println("<h1>Manipulation Session Hibernate : Technique N2 (Filtre HTTP)</h1>");
		out.println("<a href='http://www.objis.com/formation-java/formation-framework-java-hibernate.html'><img border=0 align='right' src='http://www.objis.com/formation-java/IMG/png/promo-formation-hibernate-objis.png' ALT='Votre formation HIBERNATE avec Objis, spcialiste formation java depuis 2005' title ='Votre formation HIBERNATE avec Objis, spcialiste formation java depuis 2005'/></a>");
		out.println("a y est ! Vous avez effectu un cycle de rcupration / utilisation / fermeture d'une Session hibernate grace  un filtre HTTP.");
		out.println("<p>Nous avons trac les statistiques hibernate aprs chaque fermeture de Session Hibernate");
		out.println("<p>Analysez les Statistiques de la Session hibernate dans les logs aprs chaque <a href='controleur'>sollicitation du Controleur</a>.");
		out.println("<p> 2 constats <ul><li>le nb de d'objets session utilis incrmente</li> <li> Il y a exactement le mme nb d'objets Session ouvert que ferm</li></ul>");
		out.println("<p>MEILLEURE PRATIQUE (Voir technique N3: TP 11 et 12): Mettre en oeuvre une <b>Couche de service + Dlgation vers couche DAO et autres classes</b>. Si utilisation d'un framework faire des sessions local au thread (<b>ThreadLocal</b>). ");		
		out.println("<p>Le chemin le plus court pour avoir les rflexes et la mthode du bon dveloppeur HIBERNATE : <a href='http://www.objis.com/formation-java/formation-framework-java-hibernate.html'>Formation Hibernate OBJIS</a> !");

			
		out.println("</BODY>");
		out.println("</HTML>");
		out.close();
		
	}
}
